<template>
  <el-container style="height: 100%; border: 1px solid #eee">
    <el-header>
      <el-button @click="logout">Log out</el-button>
    </el-header>

    <el-container>
      <el-aside width="200px" style="background-color: rgb(238, 241, 246)">
        <el-menu :default-openeds="['1', '1']">
          <el-submenu index="1">
            <template slot="title"><i class="el-icon-menu"/>Functions</template>
            <el-menu-item-group>
              <!-- <template slot="title">分组一</template> -->
              <el-menu-item index="1-1" v-if="this.isAdmin === true || this.isUser === true">
                <router-link tag="li" :to="{name:'userList', params:{isAdmin: this.isAdmin}}">
                  <el-link :underline="false">User</el-link>
                </router-link>
              </el-menu-item>
              <el-menu-item index="1-2" v-show="this.isAdmin === true || this.isUser === true">
                <router-link tag="li" :to="{name:'questionList'}">
                  <el-link :underline="false">Question</el-link>
                </router-link>
              </el-menu-item>
            </el-menu-item-group>
          </el-submenu>
          <el-submenu index="2">
            <template slot="title"><i class="el-icon-setting"/>Tools</template>
          </el-submenu>
        </el-menu>
      </el-aside>

      <router-view v-if="isRouterAlive"/>
    </el-container>
  </el-container>
</template>

<script>
import store from '../../store/index'
import router from '../router'
import config from '../../config/config'
import {getPermission} from '@/apis/login'

export default {
  name: '#home',
  provide () {
    return {
      reload: this.reload
    }
  },
  data () {
    return {
      isRouterAlive: true,
      isUser: false,
      isAdmin: false
    }
  },
  created () {
    getPermission().then(res => {
      console.log('Get Login User\'s Permission')
      console.log(res)
      var permissions = []
      for (let permission of res.data.authorities) {
        permissions.push(permission.authority)
      }
      this.$message.success('授权成功')

      this.$store.commit('set_permissions', permissions)
      console.log('permissions: ' + store.state.permissions)

      if (permissions.includes(config.UserRole)) {
        console.log('isUser')
        this.isUser = true
      }
      if (permissions.includes(config.AdminRole)) {
        console.log('isAdmin')
        this.isAdmin = true
      }
    }).catch(error => {
      this.loading = false
      this.loginBtn = '登录'
      this.$message.error('权限获取错误')
      console.log(error)
    })
  },
  methods: {
    reload () {
      this.isRouterAlive = false
      this.$nextTick(function () {
        this.isRouterAlive = true
      })
    },
    logout () {
      store.commit('del_token')
      store.commit('del_permissions')
      console.log('Log out')
      router.replace({
        path: '/login'
      })
    }
  }
}
</script>

<style>
  .el-header {
    background-color: #B3C0D1;
    color: #333;
    line-height: 60px;
  }

  .el-aside {
    color: #333;
  }
</style>
